%Matlab script (originally del99.m, this is version produced in Nov. 2001)
%Uses output tables from delay1d.f
%Time lags in a thin disk around Kerr are computed
%transfer function from deltran.dat added
clear all; 

%Set some variables:
deg=180./pi;
%Step for contours:
kx=1;
 ky=1;
%Number of contours:
nc=25;%134;
ncg=22;%38;
ncc=26;
%Shift for contours:
kor=0;

%Axes ranges:
%xmax0=58; xmin0=-xmax0; ymax0=xmax0; ymin0=xmin0;
 sft1=3; sft2=28;
xmax0=21; xmin0=-xmax0; ymax0=xmax0; ymin0=xmin0; sft1=1; sft2=11; 

%Choose directory containing data:
%Manually:vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
%aom=input('Give me a/M (two-digits format, e.g. 99 for a/M=0.99): ','s');
%
%inc=input('Give me inclination (two digits, e.g. 50 for th=50 deg): ','s');
%

%or in a loop:xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx                                                      
aom=['0d' '3d' '6d' '9d'];%                                                  
inc=['00' '20' '40' '60' '80'];%                                                 
%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ 
for iaom=1:2:length(aom),%
for iinc=1:2:length(inc),%

aomchar=[aom(1,iaom) aom(1,iaom+1)]; incchar=[inc(1,iinc) inc(1,iinc+1)];  

clf; %figure;

cd cat;
eval(['cd ' aomchar]);
eval(['cd ' incchar]);
pwd
%Loading data files (output from delay1d.f):
load delay.txt;
a=delay(1,1);
load delay.dat;
load delgfac.dat;
load delcosmu.dat;
load xvec.dat;
load yvec.dat;
load deltran.dat;
cd ../../..;

%Gravitational radius in M:
a2=a*a;
rg=1+sqrt(1-a2);
third=1.0/3.0;
%Marginally stable orbit:
z1=1+((1-a2).^third)*((1+a).^third+(1-a).^third);
z2=sqrt(3.D0*a2+z1*z1);
rms=3+z2-sqrt((3.D0-z1)*(3+z1+2*z2));
%Photon corotating equatorial orbit:
rph=2*(1+cos((2./3.)*acos(-a)));

%vec=xvec/rg;
%vec=yvec/rg;
lex=length(xvec);
ley=length(yvec);
is=1;
xmin=10*(round(.1*xvec(1+is)));
xmax=10*(round(.1*xvec(lex-is)));
xcnt=0;
ymin=10*(round(.1*yvec(1+is)));
ymax=10*(round(.1*yvec(ley-is)));
ycnt=0;

%Set up reference level for contours:
for i=1:lex,
 for j=1:ley,
  if delay(i,j)<0
   delay(i,j)=NaN;
  end;
  if delay(i,j)>400
   delay(i,j)=NaN;
  end;
  if delgfac(i,j)<=0
   delgfac(i,j)=NaN;
  end;
  if delcosmu(i,j)<0
   delcosmu(i,j)=NaN;
  end;  
 end;
end;

for ley1=ley:-1:ley-1,
 mindelay=min(delay(ley1,:));
 if mindelay<400,
  break;
 end;
end;

delay=delay-mindelay;

%Find contour levels for transfer function;
for i=1:lex,
 for j=1:ley,
  if deltran(i,j)<0.001
   deltran(i,j)=NaN;
  end;
 end;
end;
tranmin=min(min(deltran)); tranmax=max(max(deltran));          
for i=1:lex,                                                                    
 for j=1:ley,              
  if deltran(i,j)<tranmin+0.01;
   deltran(i,j)=NaN;                                                            
  end;                                                                          
 end;                                                                         
end;         
tranmin=0.01*floor(100*tranmin); tranmax=0.1*ceil(10*tranmax);
if tranmax-tranmin>0.2,
 %cposuv=min([0.3 tranmin]); 
 %tranmin1=min([1 tranmin+0.2]);
 %cfl=[linspace(tranmax-0.1,tranmin1+0.2,3)...
 %tranmin1+0.10 tranmin1+0.03 tranmin1+0.01 tranmin-cposuv];
 tranmin1=min([1 tranmin+0.10]);                                                 
 cfl=[linspace(tranmax,tranmin1+0.1,8)...
  tranmin1+0.06 tranmin1];  
%Contours of transfer function;        
 [cs3,hg3]=contour(xvec(1+is:ky:ley-is)+kor,yvec(1+is:kx:lex-is),...
  deltran(1+is:kx:lex-is,1+is:ky:ley-is),cfl,'m');
%colormap('copper');
%colorbar; 
end;

hold on;

%Contours of g-factor:
[cs1,hg1]=contour(xvec(1+is:ky:ley-is)+kor,yvec(1+is:kx:lex-is),...
 delgfac(1+is:kx:lex-is,1+is:ky:ley-is),ncg,'k');
set(hg1,'LineStyle','-','Color','r','LineWidth',1.2);
%white rectangles (if needed for clarity of label contours):
%hf1=fill([-2 0.5 0.5 -2],[-4.2 -4.2 -2.5 -2.5],'w');
%hf2=fill([-4.5 -2.5 -2.5 -4.5],[-5 -5 -3 -3],'w');
%set(hf1,'linestyle','none');
%set(hf2,'linestyle','none');

%Contours of time lag:
%[cs,hg0]=contour(xvec(1+is:ky:ley-is)+kor,yvec(1+is:kx:lex-is),...              
% delay(1+is:kx:lex-is,1+is:ky:ley-is),nc,'k');                                  
% set(hg0,'LineStyle','-','Color','c','LineWidth',1.3);   
[cs,hg0]=contour(xvec(1+is:ky:ley-is)+kor,yvec(1+is:kx:lex-is),...
 delay(1+is:kx:lex-is,1+is:ky:ley-is),nc,'k');
set(hg0,'LineStyle','--','Color','b','LineWidth',1.0);

%Contours of cosine of local emission angle (cosmu):
cosmu=acos(delcosmu)*deg;
%[cs2a,hg2a]=contour(xvec(1+is:ky:ley-is)+kor,yvec(1+is:kx:lex-is),...             
% cosmu(1+is:kx:lex-is,1+is:ky:ley-is),ncc,'k');                                 
%set(hg2a,'LineStyle','-','Color','w','LineWidth',1.3);   
[cs2,hg2]=contour(xvec(1+is:ky:ley-is)+kor,yvec(1+is:kx:lex-is),...
 cosmu(1+is:kx:lex-is,1+is:ky:ley-is),ncc,'k');
set(hg2,'LineStyle','-.','Color','k','LineWidth',1.0);

set(gca,'ytick',[ymin0+sft1 ymin0+sft2 ycnt ymax0-sft2 ymax0-sft1],...
 'xtick',[xmin0+sft1 xmin0+sft2 xcnt xmax0-sft2 xmax0-sft1]);
set(gca,'linewidth',1.,'ticklength',[0.02 0.04]);
set(gca,'gridlinestyle',':');

%Make contour labels:
clabel2(cs,hg0);%,'manual');
clabel2(cs1,hg1);%,'manual');
clabel2(cs2,hg2);%,'manual');
lcfl2=length(cfl); lcfl1=max([1 lcfl2-3]);
 
if tranmax-tranmin>0.2, 
 clabel3(cs3,cfl(lcfl1:lcfl2),'color','m',...
  'fontweight','bold','fontangle','italic');%,'manual');
end;

%grid on;                                                                        
axis([xmin0 xmax0 ymin0 ymax0]);                                                
axis square;             

%xlabel(' x ');
%h = get(gca,'xlabel');
%set(h,'fontsize',12,'fontname','Helvetica','fontangle','italic');
%ylabel(' y ');
%h = get(gca,'ylabel');
%set(h,'fontsize',12,'fontname','Helvetica','fontangle','italic');
%title('(a)');
%h = get(gca,'title');
%set(h,'fontsize',12,'fontname','Helvetica');
set(gca,'fontsize',14);

%Circle with radius=r_ms:
t=linspace(0,6.29,300);
xr=rms*sin(t);
yr=rms*cos(t);
plot(xr,yr,'k','linewidth',2.0);
plot(xr,yr,'y','linewidth',1.7);

%Circle with radius=r_ph+epsilon:
t=linspace(0,6.29,300);
xr=(rph+0.1)*sin(t);
yr=(rph+0.1)*cos(t);
fill(xr,yr,'y');

%Circle with radius=r_g:
t=linspace(0,6.29,300);
xr=rg*sin(t);
yr=rg*cos(t);
fill(xr,yr,'k');

hold off;

fname=['del' aomchar incchar '.eps'];
eval(['print  -depsc ' fname]);

end;
end;%of loops over different figures
